﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sandbox.Core.Models
{
    public partial class DocuSignDbContext : AutoGeneratedDbContext
    {
        //public DocuSignDbContext()
        //{
        //}

        public DocuSignDbContext(DbContextOptions<AutoGeneratedDbContext> options)
            : base(options)
        {

        }

        private void InternalSave()
        {
            //var modifiedIBaseEntities = ChangeTracker
            //.Entries()
            //.Where(e => e.Entity is IBaseEntity
            //            && e.State == EntityState.Modified);

            //foreach (var entityEntry in modifiedIBaseEntities)
            //    ((IBaseEntity)entityEntry.Entity).DateModif = DateTime.Now;

            //var slugEntityEntries = ChangeTracker
            //    .Entries()
            //    .Where(e => e.Entity is ISlugEntity
            //                && (e.State == EntityState.Added
            //                || e.State == EntityState.Modified));

            //foreach (var entityEntry in slugEntityEntries)
            //    ((ISlugEntity)entityEntry.Entity).Code = ((ISlugEntity)entityEntry.Entity).Titre.Slugify();
        }

        public override int SaveChanges()
        {
            InternalSave();
            return base.SaveChanges();
        }

        public override async Task<int> SaveChangesAsync(CancellationToken cancellationToken = default)
        {
            InternalSave();
            return await base.SaveChangesAsync(cancellationToken);
        }

        public override async Task<int> SaveChangesAsync(bool acceptAllChangesOnSuccess, CancellationToken cancellationToken = default)
        {
            InternalSave();
            return await base.SaveChangesAsync(acceptAllChangesOnSuccess, cancellationToken);
        }
    }
}
